VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 1  'vbSimpleBound
  DataSourceBehavior  = 1  'vbDataSource
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsData"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False


'Author P.PONRAJ
'Created 01-feb-2000
'This Class is Used to Add,Edit,Delete,Find and navigate Records Using Valid DataSource
'Before Use Add References Microsoft ActiveX Objects Library
Option Explicit

'Declare Private Variable
Private mblnAddNewFlag As Boolean            'Add Record Status
Private mblnEditFlag As Boolean              'Edit Record Status
Private mstrIndex As String                  'Store Index Field Name for Finding(Better performance)
Private mstrsql As String                    'Store SQL for Creating Recordset
Private mstrCON As String                    'Store Valid ConnectionString(ActiveConnection)
Private mvBookMark As Variant                'Storing Current Record Position
Private WithEvents adoPrimaryRS As Recordset 'Store Recordset
Attribute adoPrimaryRS.VB_VarHelpID = -1
Private mfldIndex As Field                   'Store Index Field
Public Event MoveComplete()                  'Event to Display Current Record Position

Private Sub Class_Initialize()
    'Initialize Variables
    mstrsql = ""
    mblnAddNewFlag = False
    mblnEditFlag = False
End Sub

Private Sub Class_GetDataMember(DataMember As String, Data As Object)
  'Check for Existing Datamember if Exists Assign Data to Recordset
  Select Case DataMember
  Case "Primary"
    Set Data = adoPrimaryRS
  End Select
End Sub

Public Sub Find(fv_sql As String)
'Procedure for Finding Record
On Error GoTo LocalErr
    mvBookMark = adoPrimaryRS.Bookmark
    adoPrimaryRS.MoveFirst
    adoPrimaryRS.Find fv_sql
    If adoPrimaryRS.EOF Then
        adoPrimaryRS.Bookmark = mvBookMark
        adoPrimaryRS.MoveFirst
        MsgBox "No Record Found", vbInformation, "Find"
    End If
Exit Sub
LocalErr:
    MsgBox Err.Number & "  " & Err.Description
End Sub

Public Sub Data(fv_opt As String)
'Procedure for Data Operation
'fv_opt parameters are any one of(ADD,EDIT,SAVE,CANCEL)
On Error GoTo LocalErr
    On Error Resume Next
    Select Case fv_opt
        Case "ADD"
            'Store Bookmark to Restore Current Position
            If Not (adoPrimaryRS.BOF And adoPrimaryRS.EOF) Then mvBookMark = adoPrimaryRS.Bookmark
            adoPrimaryRS.AddNew
            mblnAddNewFlag = True 'Add Status
        Case "EDIT"
            'Store Bookmark to Restore Current Position
            If Not (adoPrimaryRS.BOF And adoPrimaryRS.EOF) Then mvBookMark = adoPrimaryRS.Bookmark
            mblnEditFlag = True   'Edit Staus
        Case "SAVE"
            adoPrimaryRS.Update   'Update Record
            mblnEditFlag = False
            mblnAddNewFlag = False
        Case "CANCEL"
            If adoPrimaryRS.EditMode = adEditAdd Then adoPrimaryRS.CancelUpdate
            If mvBookMark > 0 Then
                adoPrimaryRS.Bookmark = mvBookMark 'Assign Bookmark Stored
            Else
                Move "LAST"
            End If
            mblnEditFlag = False
            mblnAddNewFlag = False
    End Select
    Exit Sub
LocalErr:
    MsgBox Err.Number & "  " & Err.Description
End Sub

Public Sub RSOpen()
On Error GoTo LocalErr
    DataMembers.Add "Primary" 'Add Datamember
    Set adoPrimaryRS = New Recordset
    'Open Recordset
    With adoPrimaryRS
        .ActiveConnection = ConString
        .CursorLocation = adUseClient
        .CursorType = adOpenStatic
        .LockType = adLockOptimistic
        '.CacheSize = 30
        .Source = mstrsql
        .Open
    End With
    Set mfldIndex = adoPrimaryRS.Fields(mstrIndex)
    mfldIndex.Properties("Optimize") = True
Exit Sub
LocalErr:
    MsgBox Err.Number & "  " & Err.Description
End Sub

Private Sub adoPrimaryRS_MoveComplete(ByVal adReason As ADODB.EventReasonEnum, ByVal pError As ADODB.Error, adStatus As ADODB.EventStatusEnum, ByVal pRecordset As ADODB.Recordset)
  RaiseEvent MoveComplete
End Sub

Private Sub Class_Terminate()
    'Close Opened Recordset and Free Memmory
    'Destroy Index
    On Error Resume Next
    mstrsql = ""
    mstrCON = ""
    mstrIndex = ""
    mfldIndex.Properties("Optimize") = False
    If adoPrimaryRS.State = adStateOpen Then adoPrimaryRS.Close
    Set mfldIndex = Nothing
    Set adoPrimaryRS = Nothing
End Sub

Public Sub Move(fv_option As String)
' Recordset Navigation
On Error GoTo LocalErr
    On Error Resume Next
    Select Case fv_option
        Case "FIRST"
            adoPrimaryRS.MoveFirst
        Case "NEXT"
            If Not adoPrimaryRS.EOF Then adoPrimaryRS.MoveNext
            If adoPrimaryRS.EOF And adoPrimaryRS.RecordCount > 0 Then
                Beep
                'moved off the end so go back
                adoPrimaryRS.MoveLast
            End If
        Case "PRIOR"
            If Not adoPrimaryRS.BOF Then adoPrimaryRS.MovePrevious
            If adoPrimaryRS.BOF And adoPrimaryRS.RecordCount > 0 Then
                Beep
                'moved off the end so go back
                adoPrimaryRS.MoveFirst
            End If
        Case "LAST"
            adoPrimaryRS.MoveLast
        Case "REFRESH"
            adoPrimaryRS.Requery 'Refresh Recordset  in MultiUser Environment
            DataMemberChanged "Primary"
    End Select
Exit Sub
LocalErr:
    MsgBox Err.Number & "  " & Err.Description
End Sub

Public Property Get AddFlag() As Boolean
    AddFlag = mblnAddNewFlag
End Property

Public Property Get EditFlag() As Boolean
    EditFlag = mblnEditFlag
End Property

Public Property Let ConString(ByVal vNewValue As String)
    mstrCON = vNewValue
End Property

Public Property Get ConString() As String
    ConString = mstrCON
End Property

Public Property Get AbsolutePosition() As Long
    AbsolutePosition = adoPrimaryRS.AbsolutePosition
End Property

Public Property Get SQL() As String
SQL = mstrsql
End Property

Public Property Let SQL(ByVal vNewValue As String)
mstrsql = vNewValue
End Property

Public Property Get IndexField() As Variant
IndexField = mstrIndex
End Property

Public Property Let IndexField(ByVal vNewValue As Variant)
mstrIndex = vNewValue
End Property


Public Function CheckUnique(fv_CurrVal As String, fv_Rval As String, fv_sql As String) As Boolean
On Error GoTo LocalErr
    'Simplest Way to Check Unique Fields
    Dim icnt As Integer
    Dim rsTmp As New Recordset
    With rsTmp
        .ActiveConnection = mstrCON
        .CursorLocation = adUseServer
        .CursorType = adOpenKeyset
        .LockType = adLockReadOnly
        .Source = fv_sql
        .Open
    End With
    icnt = rsTmp(0)
    If EditFlag = True Then
        If UCase(Trim(fv_CurrVal)) <> UCase(fv_Rval) And icnt > 0 Then
            CheckUnique = True
            Set rsTmp = Nothing
            Exit Function
        End If
    End If
    If AddFlag = True And icnt > 0 Then
        CheckUnique = True
        Set rsTmp = Nothing
        Exit Function
    End If
    CheckUnique = False
    Set rsTmp = Nothing
Exit Function
LocalErr:
    MsgBox Err.Number & "  " & Err.Description
End Function

Public Sub Delete()
'Delete Record
On Error GoTo LocalErr
    adoPrimaryRS.Delete
    adoPrimaryRS.MoveNext
    Move "REFRESH"
    Beep
Exit Sub
LocalErr:
    MsgBox Err.Number & "  " & Err.Description
End Sub


